/* MailTweak internal component - Copyright (C) 2007, 2008 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
function NSGetModule(compMgr, fileSpec) {
return mailtweakModule}
var mailtweakModule = {
CID: Components.ID("{8547513e-4f5a-11dc-8314-f800200c9a6b}"),contractID: "@rod.whiteley/mailtweak;1",className: "MailTweak",registerSelf: function (mgr, file, loc, type) {
mgr.QueryInterface(Components.interfaces.nsIComponentRegistrar).registerFactoryLocation(this.CID, this.className, this.contractID, file, loc, type)
with (Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager))
addCategoryEntry("app-startup", this.className, "service," + this.contractID, true, true, null),addCategoryEntry("command-line-handler", "m-mailtweak-l", this.contractID, true, true, null),addCategoryEntry("command-line-argument-handlers", "m-mailtweak-a", this.contractID, true, true, null)},getClassObject: function (aComponentManager, aCID, aIID) {
if (!aIID.equals(Components.interfaces.nsIFactory))
throw Components.results.NS_ERROR_NOT_IMPLEMENTED
if (!aCID.equals(this.CID))
throw Components.results.NS_ERROR_NO_INTERFACE
return this.factory},factory: {
createInstance: function (aOuter, aIID) {
if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION
return MailTweakService}},canUnload: function () {return true}}
MailTweakService = {
obs: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),prefBranch: null,_onetime: false,_cleanup: [],about: function (wdw, evt) {
var v0 = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getItemForID("mail-tweak@rod.whiteley").version
this._about = (this.prefBranch.getCharPref("version") != v0)
if (this._about) {
this.prefBranch.setCharPref("version", v0)
this._options = false
wdw.openDialog(
"chrome://mailtweak/content/about.xul","_blank","chrome,modal,centerscreen",this)
if (this._options) wdw.openDialog(
"chrome://mailtweak/content/options.xul","_blank","chrome,modal,centerscreen",null)}},_appliedURI: null,applyStyle: function () {
if (this._appliedURI) {
Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService).unregisterSheet(this._appliedURI, 0)
this._appliedURI = null}
var css = ""
if (this.prefBranch.getBoolPref("treefont")) {
var size = this.prefBranch.getIntPref("treefont.size")
if (size) css += "treechildren%7Bfont-size%3A" + String(size) + "px%3B%7D"}
if (this.prefBranch.getBoolPref("splitter")) {
css += "splitter[state=collapsed]:hover {background-color: Highlight !important;}"}
if (css) {
this._appliedURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI("data:text/css," + css, "", null)
Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService).loadAndRegisterSheet(this._appliedURI, 0)}},observe: function (subject, topic, data) {
switch (topic) {
case "app-startup":
this.obs.addObserver(this, "domwindowopened", false)
this.obs.addObserver(this, "em-action-requested", false)
break;
case "domwindowopened":
subject.MailTweakService = this
if (this._onetime) return
else this._onetime = true
this.prefLoad()
this.applyStyle()
TagTools.init()
var self = this
var focus = function (event) {
event.target.removeEventListener("focus", focus, false)
self.about(subject, event)}
subject.addEventListener("load",function (event) {
var tt = event.target.getElementById("threadTree")
if (!tt) return
tt.addEventListener("focus", focus, false)},false)
if (this.prefBranch.getBoolPref("prefcache"))
subject.setTimeout(
function () {MailTweakService.prefSave(true)},this.prefBranch.getIntPref("prefcache.delay"))
break;
case "em-action-requested":
var item = subject.QueryInterface(Components.interfaces.nsIUpdateItem)
if (item.id != "mail-tweak@rod.whiteley") return
switch (data) {
case "item-disabled":
this._prefCache = null
case "item-uninstalled":
this._prefCache = []
var b = this.prefBranch
var cc = b.getChildList("", {})
for each (var c in cc) {
var t = b.getPrefType(c)
var v = (t == 32)? b.getCharPref(c) : (t == 64)? b.getIntPref(c) : b.getBoolPref(c)
this._prefCache.push({name: c, type: t, value: v})}
b.deleteBranch("")
break;
case "item-cancel-action":
if (!this._prefCache) return
var b = this.prefBranch
for each (var c in this._prefCache) {
if (c.type == 32) b.setCharPref(c.name, c.value)
else if (c.type == 64) b.setIntPref(c.name, c.value)
else b.setBoolPref(c.name, c.value)}
this._prefCache = null
break;}
break;}},prefLoad: function () {
var AM = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager)
var pjs = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("PrefF", Components.interfaces.nsIFile)
var ac = null, warn = false
for (var i = 0; i < 4; ++i) {
try {ac = AM.accounts.Count()} catch (ex) {}
if (ac || i == 3) break
switch (i) {
case 0:
var pf = pjs
break
case 1:
var pb0 = pjs.parent.clone(), pb1 = pjs.parent.clone()
pb0.append("prefs.bk0"), pb1.append("prefs.bk1")
var swap = pb0.exists() && pb1.exists() && pb1.lastModifiedTime > pb0.lastModifiedTime
pf = swap? pb1 : pb0
warn = true
break
case 2:
pf = swap? pb0 : pb1
break}
if (!pf.exists()) continue
if (i > 0) {
if (pjs.exists()) try {pjs.remove(false)} catch (ex) {}
try {pf.copyTo(pjs.parent, pjs.leafName)} catch (ex) {}}
AM.UnloadAccounts()
this.pref.resetPrefs()
try {
this.pref.readUserPrefs(null)
AM.LoadAccounts()} catch (ex) {}}
if (ac && warn) {
var bn = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://mailtweak/locale/prefcache.properties")
Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService).alert(null, bn.GetStringFromName("title"), bn.GetStringFromName("warning"))}
this.prefBranch = this.pref.getBranch("extension.mailtweak.")},prefSave: function (isMain) {
var AM = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager)
try {var ac = AM.accounts.Count()} catch (ex) {var ac = 0}
if (ac == 0) return
var pf = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("PrefD", Components.interfaces.nsIFile)
pf.append("prefs.bk" + (isMain? "0":"1"))
this.pref.savePrefFile(pf)},reload: function (doMail, doAB, doComp) {
this.applyStyle()
var WW = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher)
var a = []
if (doMail) a.push({type: "mail:3pane", url: "chrome://messenger/content/messenger.xul"})
if (doAB) a.push({type: "mail:addressbook", url: "chrome://messenger/content/addressbook/addressbook.xul"})
if (doComp) a.push({type: "msgcompose", url: null})
const feat = "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar"
for each (var spec in a) {
var enum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getEnumerator(spec.type)
if (!enum.hasMoreElements()) spec.url = ""
else while (enum.hasMoreElements()) {
var w = enum.getNext()
w.close()
if (spec.url && !enum.hasMoreElements())
WW.openWindow(null, spec.url, "_blank", feat, null )}}},get disconnecter () {return Disconnecter},get personalizer () {return Personalizer},get tagtools () {return TagTools},_replyground: "",QueryInterface: function (iid) {
if (iid.equals(Components.interfaces.nsISupports)
|| iid.equals(Components.interfaces.nsICommandLineHandler))
return this
else throw Components.results.NS_ERROR_NO_INTERFACE},get helpInfo () {return " -internal <function> Call internal function\n"},handle: function (cl) {
if (cl.state == 0) return
ok = cl.handleFlag("quit", false)
if (!ok) return
var enum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getEnumerator(null)
while (enum.hasMoreElements()) {
var w = enum.getNext()
if ("goQuitApplication" in w) {
w.setTimeout(w.goQuitApplication, 0)
break}}},toString: function () {return "[object MailTweakService]"}}
Disconnecter = {
enabled: true,_tally: 0,_timer: Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer),await: function (state) {
if (state == "true") {
if (this._tally == 0) return
if (--this._tally == 0) this._timer.init(
this,MailTweakService.prefBranch.getIntPref("disconnect.delay") * 1000,0)}
else {
this._timer.cancel()
this._tally++}},observe: function () {
if (!Disconnecter.enabled) return
var DS = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties)
var name = MailTweakService.prefBranch.getCharPref("disconnect.script")
var scr = DS.get("PrefD", Components.interfaces.nsIFile).parent
scr.append(name)
if (!scr.exists()) {
scr = DS.get("ARes", Components.interfaces.nsIFile)
scr.append(name)}
if (scr.exists()) try {
var proc = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess)
proc.init(scr)
proc.run(false, null, 0)} catch (ex) {}
if (MailTweakService.prefBranch.getBoolPref("disconnect.offline")) {
var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher).getWindowEnumerator()
while (ww.hasMoreElements()) {
var w = ww.getNext().QueryInterface(Components.interfaces.nsIDOMWindow)
if ("MailOfflineMgr" in w) {
if (w.MailOfflineMgr.isOnline()) w.MailOfflineMgr.toggleOfflineStatus()
break}}}}}
Personalizer = {
IOS: Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService),MMS: Components.classes["@mozilla.org/messenger/services/session;1"].getService(Components.interfaces.nsIMsgMailSession),MSL: Components.classes["@mozilla.org/messengercompose/sendlater;1"].getService(Components.interfaces.nsIMsgSendLater),timer: Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer),make_active: false,parent: null,csvFile: null,activate: function (id) {
this._mark = MailTweakService.prefBranch.getCharPref("personal.marker")
this._uniqueid = MailTweakService.prefBranch.getBoolPref("personal.uniqueid")
this._csv_charset = MailTweakService.prefBranch.getCharPref("personal.csv.charset")
this._csv_to = MailTweakService.prefBranch.getCharPref("personal.csv.to")
this._umf = this.MSL.getUnsentMessagesFolder(id)
this._msgid = {}
var enum = this._umf.getMessages(null)
while (enum.hasMoreElements()) {
var msg = enum.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr)
this._msgid[msg.messageId] = true}
this._observercount = 50
this.timer.init(this, 100, 1)},observe: function () {
var enum = this._umf.getMessages(null)
while (enum.hasMoreElements()) {
var msg = enum.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr)
if (!this._msgid[msg.messageId]) {
this.timer.cancel()
this.process(msg)
break}}
if (--this._observercount == 0) this.timer.cancel()},process: function (msg) {
this._msg = msg
if (msg.Charset) {
this._msgConv = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter)
this._msgConv.charset = msg.Charset}
else this._msgConv = null
if (this.csvFile) {
this._recipient = []
this._card = []
this.csvLoad()
this.csvFile = null}
else {
this._recipient = msg.recipients.split(",")
this._card = []
for (var i = 0; i < this._recipient.length; ++i) {
var adr = this._recipient[i]
if (adr.indexOf("<") >= 0) adr = adr.match(/<(.*)>/)[1]
else adr = adr.replace(/^, |^ ,|^,|^ /, "")
try {this._card.push(this.abSearch(adr))}
catch (ex) {
this.error("abook", this._recipient[i])
return}}}
var url = this.MMS.ConvertMsgURIToMsgURL(this._umf.generateMessageURI(msg.messageKey), null)
var cha = this.IOS.newChannel(url, "", null)
cha.asyncOpen(this.reader, null)},abSearch: function (addr) {
var abks = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService).GetResource("moz-abdirectory://").QueryInterface(Components.interfaces.nsIAbDirectory).childNodes
while (abks.hasMoreElements()) {
var abk = abks.getNext().QueryInterface(Components.interfaces.nsIAbDirectory)
if (!abk.isRemote && !abk.isMailList) {
var cds = abk.childCards
try {
cds.first()
while (true) {
var cd = cds.currentItem().QueryInterface(Components.interfaces.nsIAbCard)
if (cd.primaryEmail == addr) return cd
cds.next()}} catch (ex) {continue}}}
throw null},csvLoad: function () {
var fs = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream)
fs.init(this.csvFile, 1, 0, 0)
var ss = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream)
ss.init(fs)
var rr = ss.read(ss.available())
ss.close(), fs.close()
if (this._csv_charset) {
var uc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter)
uc.charset = this._csv_charset
rr = uc.ConvertToUnicode(rr)}
rr = rr.split(/\r\n|\r|\n/)
var field = null
for each (var r in rr) {
if (r == "") continue
var a = r.match(/(?:^|,)(\"(?:[^\"]+|\"\")*\"|[^,]*)/g)
if (field) {
var cd = {}, rp = ""
for (var i = 0; i < a.length; ++i) {
var v = a[i].replace(/^,"|^,|^"|"$/g, "").replace(/""/g, '"')
cd[field[i]] = v
if (!rp) {
if (this._csv_to) {
if (field[i] == this._csv_to) rp = v}
else {
if (a[i].indexOf("@") >= 0) rp = v}}}
this._recipient.push(rp)
this._card.push(cd)}
else {
field = []
for (var i = 0; i < a.length; ++i) {
var v = a[i].replace(/^,"|^,|^"|"$/g, "").replace(/""/g, '"').replace(/\s/g, "_")
field.push(v)}}}},reader: {
onDataAvailable: function (req, ctx, ins, ofs, cnt) {
var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream)
sis.init(ins)
Personalizer._eml += sis.read(sis.available())},onStartRequest: function () {Personalizer._eml = ""},onStopRequest: function () {Personalizer.clone()}},clone: function () {
this._eml = this._eml.replace(/\nTo:.*\r(\n\s.*\r)*/i, "\nTo: " + this._mark + "_fullEmail" + this._mark + "\r").replace(/\nCC:.*\r/i, "").replace(/\nBCC:.*\r(\n\s.*\r)*/i, "\nBCC: " + this._mark + "_fullEmail" + this._mark + "\r")
for (var i = 0; i < this._card.length; ++i) this.clone1(i)
this._umf.getDBFolderInfoAndDB({}).DeleteMessage(this._msg.messageKey, null, true)
var PS = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService)
var send = PS.confirmEx(
this.parent,this.string("label"),this.string("sendnow").replace(/#/, this._card.length),0x7F7F,this.string("sendbtn"),this.string("leavebtn"),"",null,{})
this.parent = null
if (send == 0) this.MSL.SendUnsentMessages(this._identity)},clone1: function (n) {
var sis = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream)
var text = this.modify(this._eml, n)
var eml = {
inputStream: sis,openStreamForReading: function () {sis.setData(text, text.length)},closeStream: function () {sis.close()},QueryInterface: function (iid) {
if (iid.equals(Components.interfaces.nsIFileSpec)
|| iid.equals(Components.interfaces.nsISupports))
return this
throw Components.results.NS_NOINTERFACE;}}
Components.classes["@mozilla.org/messenger/messagecopyservice;1"].createInstance(Components.interfaces.nsIMsgCopyService).CopyFileMessage(eml, this._umf, null, false, 0, null, null)},modify: function (eml, n) {
// also avoid processing fields in attachments!
var cs = this._msgConv
var mk = this._mark
var text = eml
var tok = eml.match(new RegExp(mk + "\\w+" + mk, "g"))
var rmv = new RegExp(mk, "g")
for (var i = 0; i < tok.length; ++i) {
var sub = this._card[n][tok[i].replace(rmv, "")] || ""
if (!sub && tok[i] == this._mark + "_fullEmail" + this._mark) sub = this._recipient[n]
if (cs) sub = cs.ConvertFromUnicode(sub)
text = text.replace(new RegExp(tok[i], "g"), sub)}
if (this._uniqueid) {
var m = text.match(/Message-ID: (\S+)/)
if (m) {
var id = m[1].replace(/@/, "." + n + "@")
text = text.replace(/Message-ID: (\S+)/, "Message-ID: " + id)}}
return text},error: function (msg, sub) {
var PS = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService)
PS.alert(
this.parent,this.string("error"),this.string(msg).replace(/#/, sub) + "\n" + this.string("unsent"))
this.parent = null},_strings: null,string: function (key) {
if (!this._strings) this._strings = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://mailtweak/locale/compose.properties")
try {var s = this._strings.GetStringFromName(key)}
catch (ex) {var s = (dump("no string " + key + "\n"), "?")}
return s},toString: function () {return "[object MailTweak Personalizer]"}}
TagTools = {
TS: Components.classes["@mozilla.org/messenger/tagservice;1"].getService(Components.interfaces.nsIMsgTagService),_sheet: "",poolOK: null,// called after Options dialog changes the tags...
change: function () {
this.init()
var enum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getEnumerator("mail:3pane")
while (enum.hasMoreElements()) {
var w = enum.getNext()
this.load(w.document, true)
w.document.getElementById("threadTree").treeBoxObject.invalidate()}},init: function () {
var pool = MailTweakService.prefBranch.getCharPref("tagtools.pool")
if (pool) this.loadPool(pool)
const rgb = /#(..)(..)(..)/
this._sheet = "data:text/css,"
var gray = MailTweakService.prefBranch.getIntPref("tagtools.gray")
var tt = this.TS.getAllTags({})
for (var i = 0; i < tt.length; ++i) {
var c = tt[i].color, p = 'lc-' + c.substr(1)
if (c) {
var m = c.match(rgb)
if (!m) dump("bad rgb: " + c + "\n"), m = [0, 0, 0]
var b = (parseInt(m[1], 16) / 2 + parseInt(m[2], 16) + parseInt(m[3], 16) / 3) / 4.675
this._sheet += 'treechildren::-moz-tree-cell-text%28' + p + '%29,'
+ '.' + p + ':not%28[_moz-menuactive]%29'
+ '{color:' + c + ';}'
+ 'treechildren::-moz-tree-row%28' + p + ',selected,focus%29'
+ '{background-color:' + c + ';}'
+ 'treechildren::-moz-tree-cell-text%28' + p + ',selected,focus%29'
+ '{color:' + (b > gray? 'black':'white') + ';}'}}},load: function (doc, reload) {
if (reload) doc.styleSheets[1].deleteRule(0)
doc.styleSheets[1].insertRule('@import url(' + this._sheet + ');', 0)},loadPool: function (pool) {
this.poolOK = false
var f = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile)
try {f.initWithPath(pool)} catch (ex) {return}
var s = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream)
try {s.init(f, 1, 4, 4)} catch (ex) {return}
var DP = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser)
try {var doc = DP.parseFromStream(s, null, s.available(), "text/xml")}
catch (ex) {var doc = null}
s.close()
if (!doc) return
var tagset = doc.documentElement
if (tagset.localName != "tagset") return
var tags = doc.getElementsByTagName("tag")
if (tags.length == 0) return
var tt = this.TS.getAllTags({}), TSkey = {}
for each (var t in tt) TSkey[t.key] = t
var done = {}
for (var i = 0; i < tags.length; ++i) {
var tag = tags[i]
if (tag.parentNode != tagset) continue
var key = tag.getAttribute("key")
if (!key || done[key]) continue
var color = tag.getAttribute("color") || "#000000"
if (color != TSkey[key].color) this.TS.setColorForKey(key, color)
var ordinal = tag.getAttribute("ordinal")
if (ordinal != TSkey[key].ordinal) this.TS.setOrdinalForKey(key, ordinal)
var name = tag.firstChild.nodeValue || key
if (name != TSkey[key].tag) this.TS.setTagForKey(key, name)
TSkey[key] = null
done[key] = true}
for (var k in TSkey) if (TSkey[k]) this.TS.deleteKey(k)
this.poolOK = true}}
